package kjava.awt;

import java.util.*;


public class Choice extends Component{
    Vector items = new Vector();
    String sItem = "";
    int DX=4,DY=10; // Abstand
    boolean show = false; // Show list of choices
    javax.microedition.lcdui.Image choice=null;
    int cwidth, cheight, cy;
    

    public Choice(){
        try{
            choice  = javax.microedition.lcdui.Image.createImage("/icons/choice.png");
        }catch(Exception e){
            System.out.println("Could not load Images.");
        }
    }

    public void addItem(String s){
        items.addElement(s);
        if(sItem.equals("")) sItem = s;
        javax.microedition.lcdui.Font f = 
                javax.microedition.lcdui.Font.getFont(
                      javax.microedition.lcdui.Font.FACE_SYSTEM,
                      javax.microedition.lcdui.Font.STYLE_PLAIN,
                      javax.microedition.lcdui.Font.SIZE_SMALL);
        int w = f.stringWidth(s) + 6 + 16 + 2*DX;
        if(w>width)
              width = w;
        height   = 17+3+2*DY;
        cwidth   = width-2*DX;
        cheight  = items.size()*f.getHeight()+2;
    }

    public void select(String s){
        sItem = s;
    }


   public Event getClickEvent(int x, int y){
        if( x>DX && x<width-DX && y>DY && y<height-DY ){
			show = !show;
  			repaint();
            return null;
        }
        if( show && x>DX && x<width-DX && y>cy && y<cheight+cy ){
            y -= cy-4;
            javax.microedition.lcdui.Font f =  
                    javax.microedition.lcdui.Font.getDefaultFont();
            int i = y/f.getHeight();
            if(items.size()>i){      
                sItem = (String)items.elementAt(i);
                Event e = new Event();
                e.id = Event.ACTION_EVENT;
                e.arg = sItem;
                show = false;
                repaint();
                return e;
            }
         }
         return null;
   }

   public void paint(javax.microedition.lcdui.Graphics g){
        int c1 = Color.color(223,223,223),
            c2 = Color.color(192,192,192),
            c3 = Color.color(128,128,128);

        g.setColor(c3);
        g.drawLine(DX,DY,width-DX-1,DY);
        g.drawLine(DX,DY,DX,height-DY-1);
        g.setColor(Color.black);
        g.drawLine(DX+1,DY+1,width-DX-2,DY+1);
        g.drawLine(DX+1,DY+1,DX+1,height-DY-2);
        g.setColor(c1);
        g.drawLine(DX+1,height-DY-1,width-DX-1,height-DY-1);
        g.drawLine(width-DX-1,DY+1,width-DX-1,height-DY-1);
        g.drawImage(choice,width-DX-1-16,DY+2,g.TOP|g.LEFT);
        g.setColor(Color.white);
        g.fillRect(DX+2, DY+2,width-(3 + 16 + 2*DX),height-2*DY-3);
        g.setColor(Color.black);
        g.drawString(sItem, DX+2+3, DY, g.TOP|g.LEFT);
  
        if(show){
            int x0 = g.getClipX(), y0 = g.getClipY(), w0 = g.getClipWidth(),
                h0 = g.getClipHeight();
            javax.microedition.lcdui.Font f = 
                javax.microedition.lcdui.Font.getDefaultFont();
 
            g.setColor(Color.white);
            cy = height-DY;
            if(g.getTranslateY()+cy+cheight> 300)
                 cy = -cheight+DY;
            g.setClip( DX, cy,cwidth,cheight);
            g.fillRect(DX, cy,cwidth,cheight);
            g.setColor(Color.black);
            g.drawLine(DX, cy, DX+cwidth, cy);
            g.drawLine(DX, cy, DX, cheight+cy);
            g.drawLine(DX+cwidth-1, cy, DX+cwidth-1, cy+cheight-1);
            g.drawLine(DX, cy+cheight-1, DX+cwidth-1, cy+cheight-1);
            int ys = cy;
            for(int i=0; i<items.size(); i++){
                g.drawString((String)items.elementAt(i), DX+5, ys, g.TOP|g.LEFT);
                ys += f.getHeight();
            }
            g.setClip(x0,y0,w0,h0);
         }
    }
}

        
