package kjava.awt;


public class Scrollbar extends Component{

    public static final int HORIZONTAL = 0;
    public static final int VERTICAL = 1;

    private int orientation;
    public static final int sw = 16, sw2 = 2*sw, sw3 = 3*sw, sw4=4*sw;
    private int value = 0;
    private int minimum = 0;
    private int maximum = 100;
    private int pageincrement = 20;
    private int unitincrement = 5;

    static javax.microedition.lcdui.Image sc_up=null, sc_dn=null, 
         sc_r=null, sc_l =null, sc_b =null;


    public Scrollbar(int orientation){  
        this.orientation = orientation;
        if(sc_up==null){
             try{
                 sc_up  = javax.microedition.lcdui.Image.createImage("/icons/sc_up.png");
             }catch(Exception e){}
        }
        if(sc_dn==null){
             try{
                 sc_dn  = javax.microedition.lcdui.Image.createImage("/icons/sc_dn.png");
             }catch(Exception e){}
        }
        if(sc_l==null){
             try{
                 sc_l  = javax.microedition.lcdui.Image.createImage("/icons/sc_l.png");
             }catch(Exception e){}
        }
        if(sc_r==null){
             try{
                 sc_r  = javax.microedition.lcdui.Image.createImage("/icons/sc_r.png");
             }catch(Exception e){}
        }
        if(sc_b==null){
             try{
                 sc_b  = javax.microedition.lcdui.Image.createImage("/icons/sc_b.png");
             }catch(Exception e){}
        }

        
    }

    public void setPageIncrement (int w){
         pageincrement = w;
    }

    public void setValues(int value,
                                    int visible,
                                    int minimum,
                                    int maximum){
        this.value = value;
        this.minimum = minimum;
        this.maximum = maximum;
        repaint();
    }

    public void setValue(int newValue){
        if(newValue<minimum)
            this.value=minimum;
        else if(newValue>maximum)
            this.value = maximum;
        else
            this.value=newValue;
        repaint();
    }

    public int getValue(){
        return value;
    }

    public int getUnitIncrement(){
        return unitincrement;
    }

    public int getBlockIncrement(){
        return pageincrement;
    }



    public int getMinimum(){
        return minimum;
    }

    public int getMaximum(){
        return maximum;
    }

    private int val2pos(){
        if(maximum-minimum<=0) return sw;
        if(orientation == VERTICAL)
             return ((value-minimum)*(height-sw4))/(maximum-minimum)+sw;
        return sw + ((value-minimum)*(width-sw4))/(maximum-minimum);
    }

    private void pos2val(int pos){
        if(orientation == VERTICAL)
            value =  minimum + ((pos-sw)*(maximum-minimum))/(height-sw4);
        else
            value = minimum + ((pos-sw)*(maximum-minimum))/(width-sw4);
    }  

      

    public Event getClickEvent(int x, int y){
        if(orientation == VERTICAL){
            if(x>=0 && x<sw && y>=0){
                if(y<sw){
                    Event e = new Event();
                    e.id = Event.SCROLL_LINE_UP;
                    setValue(value-unitincrement);
                    return e;
                }else if(y<val2pos()){
                    Event e = new Event();
                    e.id = Event.SCROLL_PAGE_UP ;
                    setValue(value-pageincrement);
                    return e;
                }else if(y>=val2pos()+sw && y<height-sw2){
                    Event e = new Event();
                    e.id = Event.SCROLL_PAGE_DOWN  ;
                    setValue(value+pageincrement);
                    return e;
                }else if(y>=height-sw2 && y<height-sw){
                    Event e = new Event();
                    e.id = Event.SCROLL_LINE_DOWN   ;
                    setValue(value+unitincrement);
                    return e;
                }
            }
            return null;
        }else{
            if(y>=0 && y<sw && x>=0){
                if(x<sw){
                    Event e = new Event();
                    e.id = Event.SCROLL_LINE_UP;
                    setValue(value-unitincrement);
                    return e;
                }else if(x<val2pos()){
                    Event e = new Event();
                    e.id = Event.SCROLL_PAGE_UP ;
                    setValue(value-pageincrement);
                    return e;
                }else if(x>=val2pos()+sw && x<width-sw2){
                    Event e = new Event();
                    e.id = Event.SCROLL_PAGE_DOWN  ;
                    setValue(value+pageincrement);
                    return e;
                }else if(x>=width-sw2 && x<width-sw){
                    Event e = new Event();
                    e.id = Event.SCROLL_LINE_DOWN   ;
                    setValue(value+unitincrement);
                    return e;
                }
            }
            return null;
        }
    }


    public Event getMoveEvent(int x, int y){
        int pos = val2pos();
        if(orientation == VERTICAL){
            if( x>=0 && x<sw && y>=pos && y<pos+sw ){
                int newvalue = y-sw/2;
                if(newvalue>=sw && newvalue<=height-sw3){
                   pos2val(newvalue);//value = newvalue;
                   Event e = new Event();
                   e.id = Event.SCROLL_ABSOLUTE ;
                   repaint();
                   return e;
                }
            }
            return null;
        }else{
             if( x>=pos && x<pos+sw && y>=0 && y<sw ){
                int newvalue = x-sw/2;
                if(newvalue>=sw && newvalue<=width-sw3){
                   pos2val(newvalue);
                   Event e = new Event();
                   e.id = Event.SCROLL_ABSOLUTE ;
                   repaint();
                   return e;
                }
             }
             return null;
        }
   }

   public void getPreferredSize(){
        if(orientation == VERTICAL){
            width = sw;
            height = parent.height;
            X = parent.width - sw;
            Y = 0;
           // if(val2pos()>height-sw3) value = maximum;
        }else{
            width = parent.width;
            height = sw;
            X = 0;
            Y = parent.height-sw;
           // if(val2pos()>width-sw3) value = maximum;
        }
   }


   public void paint(javax.microedition.lcdui.Graphics g){
        int c1 = Color.color(223,223,223),
            c2 = Color.color(192,192,192);
        
        if(orientation == VERTICAL){
           g.setColor(c1);
           g.fillRect(0,0,width,height);
           g.setColor(c2);
           g.fillRect(0,height-sw,sw,sw);
           if(sc_up != null)
               g.drawImage(sc_up,0,0,g.TOP|g.LEFT);
           if(sc_b != null)
               g.drawImage(sc_b,0,val2pos(),g.TOP|g.LEFT);
           if(sc_dn != null)
               g.drawImage(sc_dn,0,height-sw-sw,g.TOP|g.LEFT);
        }else{
           g.setColor(c1);
           g.fillRect(0,0,width,height);
           g.setColor(c2);
           g.fillRect(width-sw,0,sw,sw);
           if(sc_l != null)
               g.drawImage(sc_l,0,0,g.TOP|g.LEFT);
           if(sc_b != null)
               g.drawImage(sc_b,val2pos(),0,g.TOP|g.LEFT);
           if(sc_r != null)
               g.drawImage(sc_r,width-sw-sw,0,g.TOP|g.LEFT);
        }
    }
}

        
